#include <PSX/File/Processor/cd_file_processor.hpp>
#include <CD/cd_internal.hpp>
#include <stdio.h>

namespace JabyEngine {
    void CDFileProcessor :: start_cur_job() {
        using CD::internal::FileInfo;
        using CD::internal::SectorBufferAllocator;

        const auto& cur_lba = this->lba[this->jobs.files->rel_lba_idx];

        CD::internal::read_file(FileInfo::from(cur_lba), SectorBufferAllocator::create(this, [](void* ctx) -> CD::internal::DataSector* {
            printf("Blubb?!\n");
            return nullptr;
        }));

        printf(">>> CD needs to load LBA: %i -> %i\n", cur_lba.lba, cur_lba.size_words);
    }

    void CDFileProcessor :: setup(const volatile AutoLBAEntry* lba, JobArray jobs, uint8_t* work_area) {
        this->lba       = const_cast<const AutoLBAEntry*>(lba);
        this->work_area = work_area;
        this->jobs      = jobs;

        CDFileProcessor::start_cur_job();
    }

    Progress CDFileProcessor :: process() {
        return Progress::Error;
    }
}